/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */
/*
 * Interrupt priority level definitions for the Amiga
 *
 * Author: Bryan Ford
 */

#ifndef _amiga_machparam_
#define _amiga_machparam_

/* This defines the generic spl0()..spl7() functions */
#include <motorola/m68k/machparam.h>

#ifdef SPL_DEBUG

extern int splsoftclock();
extern int splbio();
extern int splclock();
extern int spltty();
extern int splio();
extern int splsched();
extern int splvm();
extern int splhigh();

#else /* inline definitions then */

/* block software timeouts */
#define splsoftclock() spl1()

/* block SCSI interrupts */
#if defined(A3000) || defined(GVP11) || defined(A2091)
#define splbio() spl2()
#endif
#ifndef splbio
#define splbio() spl0()
#endif

/* block hardware clock interrupts */
#define splclock() spl3()

/* block serial line and keyboard interrupts */
#define spltty() spl5()

/* block network interrupts (at least SLIP, ie. spltty, if nothing else) */
#define splimp() spltty()

/* block ALL io devices (still hardcoded in ds_routines.c to splsched!!!) */
#define splio() spl5()

/* block all interrupts that may affect scheduling (eg. switch tasks) */
#define splsched() spl5()

/* not used, what was the purpose for this level? */
#define splvm() spl7()

/* block all interrupts */
#define splhigh() spl7()

#endif /* SPL_DEBUG */
#endif _amiga_machparam_
